
#include <libintl.h>
#include <locale.h>
#define _(mens) gettext(mens)
#define N_(mens) (mens)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "aplica.h"
#include "config.h"
#include "estad.h"
#include "glifos.h"
#include "grises.h"
#include "histos.h"
#include "inclina.h"
#include "imag.h"
// #include "imagio.h"
// #include "imagx.h"
#include "lectura.h"
#include "lista.h"
#include "line.h"
#include "lvent.h"
#include "opcns.h"
// #include "segmenta0.h"
#include "segmenta.h"
#include "segmenta3.h"

// comienzo_local

// static char * nombreTipoDocumento[] = {
//   "tdocumNoclasif", "tdocumColumna", "tdocumTabloide",
//   "#"
// };

void tipoDocumento (ttdocum *tdocum, tvent vent)
{
//  lista lineasHagr ;
//  lista lineasVagr ;
//  lista lineasVBagr ;
//  lista lineasHagrOrd;
//  lista lineasVagrOrd;
//  lista lineasVBagrOrd;
//  int inclv;
  prepara0 (vent);
/*
  sigueyAgrupaRayasHor (&lineasHagr, vent);
//  imprimeRayas (lineasHagr);
  ordenadasRayas (&lineasHagrOrd, lineasHagr);
  imprimeRayasCab (headNlista(lineasHagrOrd, 15), "rayas n. horizonatales");
//
  sigueyAgrupaRayasVer (&lineasVagr, vent);
//   imprimeRayas (lineasVagr);
  ordenadasRayas (&lineasVagrOrd, lineasVagr);
  imprimeRayasCab (headNlista(lineasVagrOrd, 15), "rayas n. verticales");
//
  inclv = calculaInclinacionV (vent);
  sigueyAgrupaRayasVerBlanIncl (&lineasVBagr, vent, (vent->ty * 19)/20, inclv);
//   imprimeRayas (lineasVBagr);
  ordenadasRayas (&lineasVBagrOrd, lineasVBagr);
  imprimeRayasCab (headNlista(lineasVBagrOrd, 15), "rayas b. verticales");
  *tdocum = tdocumNoclasif;
  if ((longLista(lineasHagr) > 0) ||
      (longLista(lineasVagr) > 0) ||
      (longLista(lineasVBagr) > 0) )
//    *tdocum = tdocumTabloide;
*/
    *tdocum = tdocumNoclasif;
//    printf ("ocre.segmenta3.tipoDocumento: %s\n", nombreTipoDocumento[*tdocum]);
    // exit (0);
//    *tdocum = tdocumTabloide;
}

void leedeColumnas (tglifo *nglifoH, tvent vent, int *n)
{
  tglifo glifoHoja;
  tnodol nodol;
  lista columnas;
  tglifo glifoCol;
  glifoHoja = glifoCompPaginaNuevo ();
  casaGlifoVent (glifoHoja, vent);
  columnas = vent->lvint;
  for (nodol = columnas->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
	  //             ......
    tvent ventcol;
//  int nh;
    ventcol = (tvent) nodol->aitem;
//  presentaVentana (&nh, ventcol, "sal36e.pgm", 1); para (); exit (0);
    segmReconoceRepasayEscribeColumnaP (&glifoCol, ventcol, n);
    adoptaGlifo (glifoHoja, glifoCol);
    casaGlifoVent (glifoCol, ventcol);
    }
  *nglifoH = glifoHoja;
}

void segmentaColsRayaN (tvent vent, lista lineas)
{
  tnodol nodol;
  int xant;
  int inclabs;
  tline linea;
  tvent ventanaLimpia;
  int tam, incl;
  int ultimo = 0;
  // imprimeRayasCab (lineas, "rayas n. verticales");
  xant = 0;
  // printf ("vent->tx: %4d longLista(lineas) %3d\n", vent->tx, longLista(lineas));
  for (nodol = lineas->primero; // nodol != (tnodol)0L;
                                // xant < vent->tx;
                                ! ultimo ;
                                 nodol = nodol->siguiente){
    // ventanaEnVentanaLargVer (&vcaracter, vent,
    //                          max (0, corte->u0 + dxinc),
    //                          tamanyoSegm (corte) + txinc);
    // ventanaLimpDeVentanaIncl (&vcaracterLimpia, vcaracter, fondo);
    if (nodol != (tnodol)0L) {
      linea = (tline) nodol->aitem;
      inclabs = linea->incl*vent->ty/256/256;
      tam = linea->v0 - xant - 1;
      ventanaEnVentanaLargVerInclLimpConMargen
                            (&ventanaLimpia, vent,
                             xant, tam, inclabs);
      xant = linea->v1 + 1 ;
      }
    else {                                   // nodol == (tnodo)0L
      tam = (vent->tx - 1) - xant - 1;
      ventanaEnVentanaLargVerInclLimpConMargen
                            (&ventanaLimpia, vent,
                             xant, tam, inclabs);
      // xant = vent->tx + 1;
      ultimo = 1;
      }
    // printf ("incabs: %4d, tam: %4d, xant: %4d\n", inclabs, tam, xant);
    ponerConvenVentana (ventanaLimpia, vent->conv);
    ventanaLimpia->incl = 0 ;                    // ??
    // printf ("inclinacion: %5d\n", incl);
    //  presentaVentana (&nh, vcaracterLimpia, "sal36e.pgm", 1); para (); exit (0);
    ventanaLimpia->incl = incl ;
    // anyadeVentana (ventanas, ventanaLimpia);
    anyadeVentana (vent->lvint, ventanaLimpia);
    // describeVentanas (vent, 0);
    }
  // vent->lvint = ventanas;
  // exit (0);
}

void segmentaTabloide (tvent vent, tvent *nventcuer);

void resegmentaTabloide (tvent vent)
{
  lista ventanas;
  tvent v, vx, vsub;
  ventanas = vent->lvint;
  v = (tvent) (ventanas->ultimo->aitem);
  // printf ("---- v            vv\n");
  // describeVentana (v);
  segmentaTabloide (v, &vx);
  // printf ("---- vx           vv\n");
  // describeVentana (vx);
  // printf ("---- vsub         vv\n");
  vsub = (tvent) (vx->lvint->ultimo->aitem);
  // describeVentana (vsub);
  ventanas->ultimo->aitem = (tpgen) vsub;    // parche !!
  // printf ("----\n");
}

void segmentaTabloide (tvent vent, tvent *nventcuer)
{
  lista lineasHagr ;
  lista lineasVagr ;
  lista lineasLarVagr ;
  lista lineasLargasOv ;
  lista lineasLargasOvCrec ;
  lista lineasHblanAgr ;
  tvent ventcuer;
  int hisV[MAXPIXV];
  int hisH[MAXPIXH];
  int hisHpr[MAXPIXH];
  int hisVpr[MAXPIXH];
  int incly_64k, incl_64k;
  prepara0 (vent);
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  //  imprimeRayasCab (lineasHagr, "rayas n. horizonatales");
  sigueyAgrupaRayasVer (&lineasVagr, vent);
  //  imprimeRayasCab (lineasVagr, "rayas n. verticales");
  sigueyAgrupaRayasHorBlan (&lineasHblanAgr, vent, (vent->tx * 31)/ 32);
  //  imprimeRayasCab (lineasHblanAgr, "rayas blancas horizonatales");
  incl_64k= calculaInclinacionH (vent);
  //  printf("incl_64k %4d\n", incl_64k);
  histoHorInclLinb (hisH, vent, incl_64k, 30);
  aplicaV (hisH, hisHpr, vent->ty, 8, prom);
  //  presentaHistoHorH (&nh, hisHpr, vent, "sal36h.dat", "sal36h.gpt");
  if (longLista(lineasVagr) != 0) {
      nlineasMasLargas (&lineasLarVagr, lineasVagr, 6);
      eliminaLineasMenores(lineasLarVagr, (vent->ty * 7)/10 );
      }
  if (longLista(lineasLarVagr) != 0) {
      // cambiar a las mayore que ... aadiendo     <<<
      ordenaPor_vx (&lineasLargasOv, lineasLarVagr);
      lineasLargasOvCrec = copiaListaReves (lineasLargasOv);
      segmentaColsRayaN (vent, lineasLargasOvCrec);
      // parche !!
      resegmentaTabloide (vent);
      // describeVentanas (vent, 2);
      *nventcuer = vent;
      }
  else {
    giroPeqH (vent, incl_64k);
    //
    segmentaPiedepag (vent, hisH, incl_64k);
    ventcuer = seleccionaSubventana (vent, "car");
    //
    prepara0 (ventcuer);
    incly_64k = calculaInclinacionV (ventcuer);
    //
    printf("incly_64k %4d\n", incly_64k);
    //
    histoVerInclLinb (hisV, ventcuer, incly_64k, 10);
    aplicaV (hisV, hisVpr, ventcuer->tx, 8, prom);
    //
    //  escribecarachistogr (carhisgrdeventana(ventcuer));
    segmentaCols (ventcuer, hisV, incly_64k);
    *nventcuer = ventcuer;
  }
}

void segmentayLeeTabloide (tglifo *nglifoH, tvent vent, int *n)
{
  tvent ventcuer;
  segmentaTabloide (vent, &ventcuer);
  leedeColumnas (nglifoH, ventcuer, n);
}

void eliminaBordes (tvent *nventl, tvent vent)
{
  lista lineasVagr ;
  lista lineasHagr ;
  tline lineaOeste, lineaEste;
  tline lineaNorte;
  int xi, xf, yi, yf;
  xi = 0;
  yi = 0;
  xf = vent->tx - 1;
  yf = vent->ty - 1;
  sigueyAgrupaRayasVer (&lineasVagr, vent);
  // imprimeRayasCab (lineasVagr, "eliminaBordes, rayas n. verticales");  //
  if (! listaVacia (lineasVagr)) {
    lineaOeste = (tline) lineasVagr->primero->aitem ;
    if (((lineaOeste->u1 - lineaOeste->u0)*20 >= (vent->ty - 1)*19) &&  // largo+
        ((lineaOeste->v1 - lineaOeste->v0)    <  (vent->ty    )/12) &&  // ancho-
         (lineaOeste->v0 <= 2)) {
      xi = lineaOeste->v1 + 4 ;
      }
    lineaEste = (tline) lineasVagr->ultimo->aitem ;
//    if (((lineaEste->u1 - lineaEste->u0)*20 >= (vent->ty - 1)*19) &&
//         (xf - lineaEste->v1 <= 2)) {
//      xf = lineaEste->v0 - 4 ;
//      }
    }
//
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  if (! listaVacia (lineasHagr)) {
    // imprimeRayasCab (lineasHagr, "rayas n. horizontales");
    lineaNorte = (tline) lineasHagr->primero->aitem ;
    if (((lineaNorte->u1 - lineaNorte->u0)*20 >= (vent->tx - 1)*19) &&
         (lineaNorte->v0 <= 2)) {
      yi = lineaNorte->v1 + 4 ;
      }
    }
  // printf ("eliminaBordes: xi:%4d xf:%4d\n", xi, xf);  //
  ventanaEnVentana (nventl, vent, xi, yi, xf-xi+1, yf-yi+1);
}
